//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  LawnGreen
#property indicator_color2  Red
#property indicator_color3  Gold
#property indicator_width1  4
#property indicator_width2  4
#property indicator_width3  4
#property indicator_minimum 0
#property indicator_maximum 1

//
//
//
//
//

extern string OsmaPeriods = "2,4,6;48,96,144";
extern int    OsmaPrice   = PRICE_CLOSE;

double buffUp[];
double buffDn[];
double buffNe[];
double periods[][3];
string speriods[];
int    totalPeriods;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0, buffUp); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1, buffDn); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2, buffNe); SetIndexStyle(2,DRAW_HISTOGRAM);
   
      //
      //
      //
      //
      //
      
      OsmaPeriods = StringTrimLeft(StringTrimRight(OsmaPeriods));
      if (StringSubstr(OsmaPeriods,StringLen(OsmaPeriods),1) != ";")
                       OsmaPeriods = StringConcatenate(OsmaPeriods,";");

      //
      //
      //
      //
      //
                             
         int s =  0;
         int i =  StringFind(OsmaPeriods,";",s);
         while (i > 0)
         {
            string current = StringSubstr(OsmaPeriods,s,i-s);
            ArrayResize(speriods,ArraySize(speriods)+1);
                        speriods[ArraySize(speriods)-1] = current;
            s = i + 1;
            i = StringFind(OsmaPeriods,";",s);
         }

         //
         //
         //
         //
         //
         
         totalPeriods = MathMin(ArraySize(speriods),10);
         ArrayResize(periods,totalPeriods);
         for (int k=0; k<totalPeriods; k++)
         {
            speriods[k] = speriods[k]+",";
            int p = 0;
                s = 0;
                i = StringFind(speriods[k],",",s);
                while (i > 0)
                {
                     current = StringSubstr(speriods[k],s,i-s);
                     periods[k][p] = StrToInteger(current);
                        s = i + 1;
                        i = StringFind(speriods[k],",",s);
                        p++;
                }                     
         }
   return(0);
}
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double work[][30];
#define _signal 0
#define _osma   1
#define _slope  2

//
//
//
//
//

int start()
{
   int i,r,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (ArrayRange(work,0) != Bars) ArrayResize(work,Bars);
         
   //
   //
   //
   //
   //

   for(i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
      double max = 0;
      double sum = 0;
      for (int k=0; k<totalPeriods; k++)
      {
         max++;
         int    kk = k*3;
         int    FastPeriod   = periods[k][0];
         int    SlowPeriod   = periods[k][1];
         int    SignalPeriod = periods[k][2];
         double alpha        = 2.0 /(1.0+SignalPeriod);

         //
         //
         //
         //
         //
                  
         double macd = iMA(NULL,0,FastPeriod,0,MODE_EMA,OsmaPrice,i)-iMA(NULL,0,SlowPeriod,0,MODE_EMA,OsmaPrice,i);
                work[r][kk+_signal] = work[r-1][kk+_signal]+alpha*(macd-work[r-1][kk+_signal]);
                work[r][kk+_osma]   = macd-work[r][kk+_signal];
                work[r][kk+_slope]  = work[r-1][kk+_slope];
                  if (work[r][kk+_osma]>work[r-1][kk+_osma]) work[r][kk+_slope]= 1;
                  if (work[r][kk+_osma]<work[r-1][kk+_osma]) work[r][kk+_slope]=-1;
                     sum += work[r][kk+_slope];
      }

      //
      //
      //
      //
      //
      
      buffUp[i] = EMPTY_VALUE;
      buffDn[i] = EMPTY_VALUE;
      buffNe[i] = EMPTY_VALUE;
         if (sum== max) buffUp[i] = 1;
         if (sum==-max) buffDn[i] = 1;
         if (buffDn[i]==EMPTY_VALUE && buffUp[i]==EMPTY_VALUE) buffNe[i] = 1;
         
   }      
   return(0);
}